{$IFDEF VER40 }

  {$R-,S-,I-,D-,T-,F-,V-,B-,N-,L- }
  {$M 16384,0,655360 }

{$ELSE }

  {$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }
  {$M 16384,0,655360 }

{$ENDIF }

(*********************************************************)
(*               GESTION VIDEO ELEMENTAIRE               *)
(*               VIDEOSYS V1.5  26/01/89                 *)
(*********************************************************)
unit videosys;
interface
uses dos;

const VERSION = '1.5';
      DATEVER = '06/09/88';

type WindFixe_map  = record
                       Free : boolean;
                       Xhaut,Yhaut,Xbas,Ybas : byte;
                       long : word;
                       seg,ofs : word;
                     end;
const
    MaxWindFixe     = 20; (* nbre max de fichier fenetre *)
var
    WindFixe : array[1..MaxWindFixe] of WindFixe_map;

type
     line_map       = record
                        car : byte; (* caractere *)
                        att : byte; (* attribut *)
                      end;
const
    LongWindPile : byte = 0;
var
    Scrline        : array[1..80] of line_map;
    OfsMemVideo, SegMemVideo : word;
    PointMemVideo  : pointer absolute OfsMemVideo;

procedure ScrMove ( var source, destination; long : integer);
procedure GetScrline ( line : byte);
procedure PutScrline ( line : byte);
procedure GetScrField ( x,y,long : byte);
procedure PutScrField ( x,y,long : byte);
procedure GoScrField ( x,y,long : byte);
procedure WriteScr(texte : string ; attrib,x,y : byte);
procedure wrtbyte ( data : byte; attrib : byte; x,y :byte);
procedure wrttexte (texte : string; attrib,x,y : byte);
procedure DepileNoWind;
procedure DepileWindTo(Xhaut,Yhaut : byte);
procedure EmpileWind(Xhaut,Yhaut,Xbas,Ybas : byte);
procedure DepileWind;
procedure ClrZone(Xhaut,Yhaut,Xbas,Ybas,att : byte);
procedure ClrMemVideo;
procedure WindAspect(Xhaut,Yhaut,Xbas,Ybas,Att : byte);
function VideoMode : byte;
procedure SetVideoMode(what : byte);
function VideoCarte : byte;
function DetectAdrGraph : pointer;
procedure OpenVideoSys(WorkAdrVideo : pointer; Neige : boolean );
procedure CloseVideoSys;
procedure CloseWind(NumFich : byte);
function SaveWind(Xhaut,Yhaut,Xbas,Ybas : byte) : byte;
procedure RestoreWind(NumFich : byte);
procedure RestoreWindTo(NumFich,Xhaut,Yhaut : byte);
procedure PutFixe(NumFich : byte; var source; long : integer);

implementation

(********************* FASTSCR **********************)

var
     OfsVideo, SegVideo : word;
     PointAdrVideo  : pointer absolute OfsVideo;
     LargeLine      : byte;
     VideoNeige     : boolean;

procedure ScrMove ( var source, destination; long : integer);
begin
  if VideoNeige then
    (* machine afin d'eviter la neige *)
    inline($1E/$55/$BA/$DA/$03/$C5/$B6/ source /$C4/$BE/
           destination /$8B/$8E/ long /$FC/$AD/$89/$C5/$B4/
           $09/$EC/$D0/$D8/$72/$FB/$90/$EC/$20/$E0/$74/$FB/
           $89/$E8/$AB/$90/$E2/$EA/$5D/$1F)
  else (* rien a craindre de la neige *)
    move (source,destination,long*2);
end;

procedure GetScrline ( line : byte);
begin
  move(Mem[SegMemVideo:OfsMemVideo+line*LargeLine],Scrline,LargeLine);
end;

procedure PutScrline ( line : byte);
begin
  ScrMove(Scrline,Mem[SegVideo:OfsVideo+line*LargeLine],LargeLine div 2);
  move (Scrline,Mem[SegMemVideo:OfsMemVideo+line*LargeLine],LargeLine);
end;

procedure GetScrField ( x,y,long : byte);
begin
  move (mem[SegMemVideo:OfsMemVideo+ x shl 1+y*LargeLine],Scrline[x+1],long*2);
end;

procedure PutScrField ( x,y,long : byte);
begin
  ScrMove(Scrline[x+1],Mem[SegVideo:OfsVideo+x shl 1+y*LargeLine],long);
  move(Scrline[x+1],Mem[SegMemVideo:OfsMemVideo+ x shl 1+y*LargeLine],long*2);
end;

procedure GoScrField ( x,y,long : byte);
begin
  ScrMove(Scrline[x+1],Mem[Segvideo:OfsVideo+x shl 1+y*LargeLine],long);
end;

procedure WriteScr(texte : string ; attrib,x,y : byte);
var index : byte;
begin
  for index := 1 to length(texte) do
    begin
      Scrline[x+index].car := byte(texte[index]);
      Scrline[x+index].att := attrib;
    end;
  PutScrField (x,y,length(texte));
end;

procedure wrtbyte ( data,attrib,x,y :byte);
(* l'element CS a ete vire de la routine machine, car cause de parasite!! *)
var ptrvideo : pointer;
begin
  ptrvideo := ptr(SegVideo,OfsVideo+x shl 1+y*LargeLine);
  inline ($06/$C4/$BE/ ptrvideo /$BA/$DA/$03/$8A/$BE/
          attrib /$8A/$9E/ data /$A1/ VideoNeige /$D1/$D8/
          $73/$0A/$EC/$D0/$D8/$72/$FB/$EC/$D0/$D8/
          $73/$FB/$89/$D8/$AB/$07);
  memw[SegMemVideo:OfsMemVideo+x shl 1+y*LargeLine] := (attrib shl 8) or data;
end;

procedure wrttexte (texte : string; attrib,x,y : byte);
var index : byte;
begin
  for index := 1 to length(texte) do
    wrtbyte ( byte(texte[index]),attrib,index+x-1,y);
end;

(******************* COMMANDE ********************)

procedure ClrZone(Xhaut,Yhaut,Xbas,Ybas,att : byte);
var index : byte;
    buf_texte : string[80];
    LongBuf : byte absolute buf_texte;
begin
  LongBuf := (Xbas+1)-Xhaut;
  FillChar(buf_texte[1],LongBuf,32);
  for index := Yhaut to Ybas do WriteScr(buf_texte,att,Xhaut,index);
end;

procedure ClrMemVideo;
var index : word;
begin
  index := 0;
  repeat
    memw[SegMemVideo:OfsMemVideo+index] := $0E20;
    Inc(index,2);
  until index>((LargeLine*25)-2)
end;

procedure WindAspect(Xhaut,Yhaut,Xbas,Ybas,Att : byte);
var ligne,colonne : byte;
    long  : byte;
begin
  long := ((Xbas+1)-Xhaut);
  for ligne := Yhaut to Ybas do
    begin
      move(Mem[SegMemVideo:OfsMemVideo+(Xhaut shl 1)+ligne*LargeLine],
           ScrLine[Xhaut+1].car,
           long shl 1);
      for colonne := Xhaut+1 to Xbas+1 do
        ScrLine[colonne].att := att;
      PutScrField(Xhaut,ligne,long);
    end;
end;

(***********************  WIND **************************)
type Wind_map  = record
                   Xhaut,Yhaut,Xbas,Ybas : byte;
                   long : word;
                   seg,ofs : word;
                 end;
const
    MaxWindPile      = 20; (* 20 niveaux de pile pour les fenetres *)

var
    WindPile : array[1..MaxWindPile] of wind_map;

procedure DepileNoWind;
(* depile la fenetre de sauve sans l'afficher a l'ecran *)
var point : pointer;
begin
  if LongWindPile>0 then
    begin
      point := ptr(WindPile[LongWindPile].seg,WindPile[LongWindPile].ofs);
      FreeMem(point,WindPile[LongWindPile].long);
      Dec(LongWindPile);
    end;
end;

procedure EmpileWind(Xhaut,Yhaut,Xbas,Ybas : byte);
(* sauvegarde la portion d'ecran designe dans une pile *)
var point : pointer;
    ligne : byte;
    longligne : byte;
begin
  if LongWindPile<MaxWindPile then
    begin
      Inc(LongWindPile);
      longligne := (Xbas+1)-Xhaut;
      WindPile[LongWindPile].Xhaut := Xhaut;
      WindPile[LongWindPile].Yhaut := Yhaut;
      WindPile[LongWindPile].Xbas := Xbas;
      WindPile[LongWindPile].Ybas := Ybas;
      WindPile[LongWindPile].long := (longligne*((Ybas+1)-Yhaut)) shl 1;
      GetMem(point,WindPile[LongWindPile].long);
      WindPile[LongWindPile].seg := seg(point^);
      WindPile[LongWindPile].ofs := ofs(point^);
      for ligne := Yhaut to Ybas do
        begin
          move(mem[SegMemVideo:OfsMemVideo+Xhaut shl 1+ligne*LargeLine],
               mem[WindPile[LongWindPile].seg:WindPile[LongWindPile].ofs+
                   (ligne-Yhaut)*(longligne shl 1)],longligne shl 1);
        end;
    end;
end;

procedure DepileWind;
(* reaffiche la derniere portion d'ecran sauve *)
var point : pointer;
    ligne : byte;
    longligne : byte;
begin
  if LongWindPile>0 then
    begin
      longligne := (WindPile[LongWindPile].Xbas+1)-
                    WindPile[LongWindPile].Xhaut;
      for ligne := WindPile[LongWindPile].Yhaut to
                   WindPile[LongWindPile].Ybas do
        begin
          move(mem[WindPile[LongWindPile].seg:WindPile[LongWindPile].ofs+
                   (ligne-WindPile[LongWindPile].Yhaut)*(longligne shl 1)],
               mem[SegMemVideo:OfsMemVideo+WindPile[LongWindPile].Xhaut shl 1
                   +ligne*LargeLine],
                   longligne shl 1);
          move(mem[SegMemVideo:OfsMemVideo+WindPile[LongWindPile].Xhaut shl 1
                   +ligne*LargeLine],
               Scrline[WindPile[LongWindPile].Xhaut+1],
               longligne shl 1);
          GoScrField (WindPile[LongWindPile].Xhaut,
                       ligne,
                       longligne);
        end;
      point := ptr(WindPile[LongWindPile].seg,WindPile[LongWindPile].ofs);
      FreeMem(point,WindPile[LongWindPile].long);
      Dec(LongWindPile);
    end;
end;

procedure DepileWindTo(Xhaut,Yhaut : byte);
var diffX,diffY : integer;
begin
  if LongWindPile>0 then
    begin
      diffX := WindPile[LongWindPile].Xhaut-Xhaut;
      diffY := WindPile[LongWindPile].Yhaut-Yhaut;
      WindPile[LongWindPile].Xhaut := WindPile[LongWindPile].Xhaut-diffX;
      WindPile[LongWindPile].Yhaut := WindPile[LongWindPile].Yhaut-diffY;
      WindPile[LongWindPile].Xbas := WindPile[LongWindPile].Xbas-diffX;
      WindPile[LongWindPile].Ybas := WindPile[LongWindPile].Ybas-diffY;
      DepileWind;
    end;
end;

(***********************  WIND FIXE !! **************************)

function SearchFixeFree(Free : boolean) : byte;
(* retourne le numero du premier fichier ouvert ou ferme rencontre *)
(* si 0 alors aucun fichier correspond *)
var NumFich : byte;
begin
  for NumFich := 1 to MaxWindFixe do
    if Free=WindFixe[NumFich].Free then
      begin
        SearchFixeFree := NumFich;
        exit;
      end;
  SearchFixeFree := 0; (* rien trouve!! *)
end;

procedure CloseWind(NumFich : byte);
var point : ^byte;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      point := ptr(WindFixe[NumFich].seg,WindFixe[NumFich].ofs);
      FreeMem(point,WindFixe[NumFich].long);
      WindFixe[NumFich].Free := true;
    end;
end;

function SaveWind(Xhaut,Yhaut,Xbas,Ybas : byte) : byte;
(* sauvegarde la portion d'ecran designe dans un pseudo fichier *)
var point : pointer;
    ligne : byte;
    longligne : byte;
    NumFich : byte;
begin
  NumFich := SearchFixeFree(true);
  if NumFich>0 then
    begin
      WindFixe[NumFich].Free := false;
      longligne := (Xbas+1)-Xhaut;
      WindFixe[NumFich].Xhaut := Xhaut;
      WindFixe[NumFich].Yhaut := Yhaut;
      WindFixe[NumFich].Xbas := Xbas;
      WindFixe[NumFich].Ybas := Ybas;
      WindFixe[NumFich].long := (longligne*((Ybas+1)-Yhaut)) shl 1;
      GetMem(point,WindFixe[NumFich].long);
      WindFixe[NumFich].seg := seg(point^);
      WindFixe[NumFich].ofs := ofs(point^);
      for ligne := Yhaut to Ybas do
        begin
          move(mem[SegMemVideo:OfsMemVideo+Xhaut shl 1+ligne*LargeLine],
               mem[WindFixe[NumFich].seg:WindFixe[NumFich].ofs+
                   (ligne-Yhaut)*(longligne shl 1)],longligne shl 1);
        end;
    end;
  SaveWind := NumFich;
end;

procedure RestoreWind(NumFich : byte);
(* reaffiche la portion d'ecran sauve par SaveWind *)
(* le fichier n'est pas clos! *)
var point : pointer;
    ligne : byte;
    longligne : byte;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      longligne := (WindFixe[NumFich].Xbas+1)-
                    WindFixe[NumFich].Xhaut;
      for ligne := WindFixe[NumFich].Yhaut to
                   WindFixe[NumFich].Ybas do
        begin
          move(mem[WindFixe[NumFich].seg:WindFixe[NumFich].ofs+
                   (ligne-WindFixe[NumFich].Yhaut)*(longligne shl 1)],
               mem[SegMemVideo:OfsMemVideo+WindFixe[NumFich].Xhaut shl 1
                   +ligne*LargeLine],
                   longligne shl 1);
          move(mem[SegMemVideo:OfsMemVideo+WindFixe[NumFich].Xhaut shl 1
                   +ligne*LargeLine],
               Scrline[WindFixe[NumFich].Xhaut+1],
               longligne shl 1);
          GoScrField (WindFixe[NumFich].Xhaut,
                       ligne,
                       longligne);
        end;
    end;
end;

procedure RestoreWindTo(NumFich,Xhaut,Yhaut : byte);
var diffX,diffY : integer;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      diffX := WindFixe[NumFich].Xhaut-Xhaut;
      diffY := WindFixe[NumFich].Yhaut-Yhaut;
      WindFixe[NumFich].Xhaut := WindFixe[NumFich].Xhaut-diffX;
      WindFixe[NumFich].Yhaut := WindFixe[NumFich].Yhaut-diffY;
      WindFixe[NumFich].Xbas := WindFixe[NumFich].Xbas-diffX;
      WindFixe[NumFich].Ybas := WindFixe[NumFich].Ybas-diffY;
      RestoreWind(NumFich);
    end;
end;

procedure RestoreWindToRam(NumFich : byte);
(* restoration en ram uniquement et non sur l'ecran *)
var point : pointer;
    ligne : byte;
    longligne : byte;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      longligne := (WindFixe[NumFich].Xbas+1)-
                    WindFixe[NumFich].Xhaut;
      for ligne := WindFixe[NumFich].Yhaut to
                   WindFixe[NumFich].Ybas do
        begin
          move(mem[WindFixe[NumFich].seg:WindFixe[NumFich].ofs+
                   (ligne-WindFixe[NumFich].Yhaut)*(longligne shl 1)],
               mem[SegMemVideo:OfsMemVideo+WindFixe[NumFich].Xhaut shl 1
                   +ligne*LargeLine],
                   longligne shl 1);
        end;
    end;
end;

procedure RestoreWindToRamTo(NumFich,Xhaut,Yhaut : byte);
var diffX,diffY : integer;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      diffX := WindFixe[NumFich].Xhaut-Xhaut;
      diffY := WindFixe[NumFich].Yhaut-Yhaut;
      WindFixe[NumFich].Xhaut := WindFixe[NumFich].Xhaut-diffX;
      WindFixe[NumFich].Yhaut := WindFixe[NumFich].Yhaut-diffY;
      WindFixe[NumFich].Xbas := WindFixe[NumFich].Xbas-diffX;
      WindFixe[NumFich].Ybas := WindFixe[NumFich].Ybas-diffY;
      RestoreWindToRam(NumFich);
    end;
end;

procedure PutFixe(NumFich : byte; var source; long : integer);
var point : pointer;
begin
  if not(WindFixe[NumFich].Free) then
    begin
      if long>WindFixe[NumFich].long then long := WindFixe[NumFich].long;
      point := ptr(WindFixe[NumFich].seg,WindFixe[NumFich].ofs);
      move(source,point^,long);
    end;
end;

function VideoMode : byte;
var reg : registers;
begin
  reg.AH := $0F;
  Intr($10,reg);
  VideoMode := reg.AL;
end;

procedure SetVideoMode(what : byte);
var reg : registers;
begin
  reg.AX := what;
  Intr($10,reg);
end;

function VideoCarte : byte;
var reg : registers;
begin
  Intr($11,reg);
  VideoCarte := (reg.AL and (16+32)) shr 4;
end;

function DetectAdrGraph : pointer;
begin
  if VideoCarte=3 then DetectAdrGraph := ptr($B000,$0000)
  else DetectAdrGraph := ptr($B800,$0000);
end;

procedure OpenVideoSys(WorkAdrVideo : pointer;
                       Neige : boolean );
begin
  PointAdrVideo := WorkAdrVideo;
  VideoNeige    := Neige;
  LargeLine := 160;
  GetMem(PointMemVideo,LargeLine*25);
  ClrMemVideo;
  LongWindPile := 0;
end;

procedure CloseVideoSys;
begin
  while(LongWindPile>0) do DepileNoWind;
  FreeMem(PointMemVideo,LargeLine*25);
end;

var index : byte;
begin
  LongWindPile := 0;
  for index := 1 to MaxWindFixe do WindFixe[index].Free := true;
end.
